% generate optimal x, s according to Tp and Td and corresponding A, b, c:
% Tp stores the type of each primal block.
% Td stores the type of each dual block.
% Scalex stores the 0 entry of x. Scales stores the 0 entry of s.

x = [0;0]; s = [0;0];  % To ensure x and s are column vectors.
p = 1;  % Starting position of next block.

% generate x and s.
for i = 1 : blck

 % generate o block:
 if Tp(i) == 'o'

     % generate s:
       
     % each element of s^bar is a random number.
     s(p+1: p+N(i)-1) = rand(N(i)-1,1)-0.5;

     % calculate s^bar
     s(p) = norm(s(p+1 : p+N(i)-1));

     if Td(i) == 'i'
       % times rand to ensure ||s^bar|| is less than s_0.
        s(p+1:p+N(i)-1) = s(p+1:p+N(i)-1)/s(p)*rand*Scales(i);
     else
        % s is on the boundary
        s(p+1:p+N(i)-1) = s(p+1:p+N(i)-1)/s(p)*Scales(i);
     end

     % Scales(i) is s_0.
     s(p) = Scales(i);

     % x=0:
     x(p:p+N(i)-1) = 0;

  % generate boundary block:
  elseif Tp(i) == 'b'

     % generate x:
     x(p+1: p+N(i)-1) = rand(N(i)-1,1)-0.5;
     x(p) = norm(x(p+1 : p+N(i)-1));
     x(p+1:p+N(i)-1) = x(p+1:p+N(i)-1)/x(p)*Scalex(i);
     x(p) = Scalex(i);

     % generate s 

     if Td(i) == 'b'
        s(p) = Scales(i);
        s(p+1:p+N(i)-1) = -Scales(i)*x(p+1:p+N(i)-1)/Scalex(i);

     else
        % s is 0
        s(p:p+N(i)-1) = 0;
     end

  % generate interior block:
  elseif Tp(i) == 'i'

     % s = 0:
     s(p:p+N(i)-1)=0;

     % generate x, same as when s in interior.
     x(p+1 : p+N(i)-1) = rand(N(i)-1,1)-0.5; 
     x(p) = norm(x(p+1 : p+N(i)-1));
     x(p+1:p+N(i)-1) = x(p+1:p+N(i)-1)/x(p)*rand*Scalex(i);
     x(p) = Scalex(i);
  end
 
     p = p+N(i); % calculate the starting position of next block.
end

p = p-1;

% generate A, b and c
   A = rand(m, p)-0.5*ones(m, p);  %ScaleA is a number, so A is scaled to that range.
   while rank(A)< m
      A = rand(m,p)-0.5*ones(m,p);
   end
   A = ScaleA * A * 2; % times 2 because rand-0.5 is in (-0.5, 0.5)
   b = A*x;
   y = Scaley* 2*(rand(m, 1)-0.5*ones(m,1));  % y is scaled to the range Scaley.
   c = A'*y + s;
