% Evaluate function value -F at (omega,lambda,z).  
% column order: omega, lambda, z, y.
% row order: optimality, linear constraints, normality of z, complementarity.
% initialization, ensure F is a column vector.
  F = zeros(jlast,1);

  for i = 1 : blck;
    % rows for optimality.
     F(M(i)) = omega(i,1)+omega(i,2);
     F(M(i)+1:M(i)+N(i)-1) = (omega(i,1)-omega(i,2))*z(M(i)-i+1:M(i+1)-i-1);

     t = dmsn+1;  % current starting row of F to fill.

    % linear constraints
     F(t:t+m-1) = F(t:t+m-1)+(lambda(i,1)+lambda(i,2))*A(:, M(i)) + (lambda(i,1)-lambda(i,2))*A(:, M(i)+1:M(i+1)-1)*z(M(i)-i+1:M(i+1)-i-1);

     t = t+m-1;

    % normality of z
     F(t+i) = 1-z(M(i)+1-i:M(i+1)-i-1)'*z(M(i)+1-i:M(i+1)-i-1);

    % complementarity
     F(t+blck+2*i-1) = -min([lambda(i,1), omega(i,1)]);
     F(t+blck+2*i) = -min([lambda(i,2), omega(i,2)]);
     t = t+1;
  end 

  F(1:dmsn) = c-A'*y-F(1:dmsn);
  F(dmsn+1:dmsn+m) = b-F(dmsn+1:dmsn+m);
