% Evaluate Jacobian at (omega,lambda,z).  
% column order: omega, lambda, z, y.
% row order: optimality, linear constraints, normality of z, complementarity.
% initialization.
  J=0;

% rows for optimality.
  for i = 1 : blck;
    % columns for omega. 
     J(M(i),2*i-1) = 1;
     J(M(i)+1:M(i+1)-1,2*i-1) = z(M(i)-i+1:M(i+1)-i-1);
     J(M(i),2*i) = 1;
     J(M(i)+1:M(i+1)-1,2*i) = -z(M(i)-i+1:M(i+1)-i-1);


    % columns for z.
     J(M(i)+1:M(i+1)-1, jz+M(i)-i:jz+M(i+1)-i-2) = (omega(i,1)-omega(i,2))*eye(N(i)-1);

    % current starting row of J to fill
     t = dmsn+1;

    % linear constraints
      % columns corresponding to lambda
       Az = A(:, M(i)+1:M(i+1)-1)*z(M(i)-i+1:M(i+1)-i-1);
       J(t:t+m-1, jlambda+2*i-2) = A(:, M(i))+Az;
       J(t:t+m-1, jlambda+2*i-1) = A(:, M(i))-Az;

      % columns correspoding to z
       J(t:t+m-1, jz+M(i)-i:jz+M(i+1)-i-2) = (lambda(i,1)-lambda(i,2))*A(:, M(i)+1:M(i+1)-1);
 
     t = t+m-1;

    % normality of z
     J(t+i, jz+M(i)-i:jz+M(i+1)-i-2) = 2*z(M(i)-i+1:M(i+1)-i-1)';

     t = t+ blck;

    % complementarity
     if lambda(i,1) == omega(i,1)
        J(t+2*i-1, 2*i-1) = 1/2;
        J(t+2*i-1, jlambda+2*i-2) = 1/2;
     elseif lambda(i,1) < omega(i,1) 
        J(t+2*i-1, jlambda+2*i-2) = 1;
     else
        J(t+2*i-1, 2*i-1) = 1;
     end

     if lambda(i,2) == omega(i,2)
        J(t+2*i, 2*i) = 1/2;
        J(t+2*i, jlambda+2*i-1) = 1/2;
     elseif lambda(i,2) < omega(i,2) 
        J(t+2*i, jlambda+2*i-1) = 1;
     else
        J(t+2*i, 2*i) = 1;
     end

  end 
  
  J(1:dmsn, jy:jlast) = A';
