% Evaluate Jacobian at (omega,lambda,z).  
% column order: omega, lambda, z, y.
% row order: optimality, linear constraints, normality of z, complementarity.
% initialization.
  J=0;

% rows for optimality.
  for i = 1 : blck;

     if omega(i) > 0
       % columns for omega. 
       J(M(i),i) = z(M(i));    
       J(M(i)+1:M(i)+N(i)-1,i) = -z(M(i)+1:M(i)+N(i)-1);

       % columns for z.
       J(M(i),jz+M(i)-1) = omega(i);
       J(M(i)+1:M(i)+N(i)-1, jz+M(i):jz+M(i)+N(i)-2) = -omega(i)*eye(N(i)-1);

     elseif omega(i) == 0
       J(M(i),i) = z(M(i))/2;    
       J(M(i)+1:M(i)+N(i)-1,i) = -z(M(i)+1:M(i)+N(i)-1)/2;
     end  
  end
   J(1:dmsn, jy:jlast) =  A';

% current starting row of J to fill
  t = dmsn+1;

% linear constraints
  for i = 1 : blck;
     if lambda(i) > 0
      % columns corresponding to lambda
       J(t:t+m-1, jlambda+i-1) = A(1:m, M(i):M(i)+N(i)-1)*z(M(i):M(i)+N(i)-1);
      % columns correspoding to z
       J(t:t+m-1, jz+M(i)-1:jz+M(i)+N(i)-2) = lambda(i)*A(1:m, M(i):M(i)+N(i)-1);
     elseif lambda(i) == 0
       J(t:t+m-1, jlambda+i-1) = A(1:m, M(i):M(i)+N(i)-1)*z(M(i):M(i)+N(i)-1)/2;
     end
 end
 
  t = t+m;

% normality of z
  for i = 1 : blck;
    J(t, jz+M(i)-1) = 1;
    t = t+1;
  end

% complementarity
  for i = 1 : blck;

     if omega(i) < 0
        J(t, i) = 1;
     elseif omega(i) == 0
        J(t, i) = 1/2;
     end

     if lambda(i) < 0
        J(t, jlambda+i-1) = 1;
     elseif lambda(i) == 0
        J(t, jlambda+i-1) = 1/2;
     end

        J(t, jz+ M(i)-1) = 2;
        J(t, jz+ M(i): jz+M(i) + N(i) - 2) = -2* z( M(i) + 1: M(i) + N(i) -1)'; 

     t = t+1;
  end 
