% Evaluate function value -F at (omega,lambda,z).  Called by Jacob.m 
% column order: omega, lambda, z, y.
% row order: optimality, linear constraints, normality of z, complementarity.

% initialization, ensure F is a column vector.
  F = zeros(jlast,1);

% rows for optimality.
  for i = 1 : blck;
     F(M(i)) = omega(i)*z(M(i));
     F(M(i)+1:M(i)+N(i)-1) = -omega(i)*z(M(i)+1:M(i)+N(i)-1);
  end

  F(1:dmsn) = c-A'*y-F(1:dmsn);

  t = dmsn+1;  % current starting row of F to fill.

% linear constraints
  for i = 1 : blck;
       F(t:t+m-1) = F(t:t+m-1)+lambda(i)*A(1:m, M(i):M(i)+N(i)-1)*z(M(i):M(i)+N(i)-1);
  end
  F(t:t+m-1) = b-F(t:t+m-1);
  t = t+m;

% normality of z
  for i = 1 : blck;
    F(t) = 1-z(M(i));
    t = t+1;
  end

% complementarity
  for i = 1 : blck;
    zc = z(M(i))*z(M(i))-z(M(i)+1:M(i)+N(i)-1)'*z(M(i)+1:M(i)+N(i)-1);
     F(t) = -min([lambda(i), omega(i), zc]);
     t = t+1;
  end 
