% Evaluate Jacobian at (omega,lambda,z). Don't use any sparse structure. 
% Called by Jacob.m
% column order: omega, lambda, z, y.
% row order: optimality, linear constraints, normality of z, complementarity.

% initialization.
  J=0;

% rows for optimality.
  for i = 1 : blck;
    % columns for omega. 
     J(M(i),i) = z(M(i));    
     J(M(i)+1:M(i)+N(i)-1,i) = -z(M(i)+1:M(i)+N(i)-1);

    % columns for z.
     J(M(i),jz+M(i)-1) = omega(i);
     J(M(i)+1:M(i)+N(i)-1, jz+M(i):jz+M(i)+N(i)-2) = -omega(i)*eye(N(i)-1);
  end
   J = [J, A'];

% current starting row of J to fill
  t = dmsn+1;

% linear constraints
  for i = 1 : blck;
      % columns corresponding to lambda
       J(t:t+m-1, jlambda+i-1) = A(1:m, M(i):M(i)+N(i)-1)*z(M(i):M(i)+N(i)-1);
      % columns correspoding to z
       J(t:t+m-1, jz+M(i)-1:jz+M(i)+N(i)-2) = lambda(i)*A(1:m, M(i):M(i)+N(i)-1);
  end
 
  t = t+m;

% normality of z
  for i = 1 : blck;
    J(t, jz+M(i)-1) = 1;
    t = t+1;
  end

% complementarity
  for i = 1 : blck;
     zc = z(M(i))*z(M(i))-z(M(i)+1:M(i)+N(i)-1)'*z(M(i)+1:M(i)+N(i)-1);
     loz = min ([lambda(i), omega(i), zc]);

     if loz == omega(i)
       J(t, i) = 1;

     elseif loz == lambda(i)
       J(t, jlambda+i-1) = 1;  

     else
       J(t, jz+M(i)-1) = 2;
       J(t, jz+M(i):jz+M(i)+N(i)-2) = -2*z(M(i)+1:M(i)+N(i)-1)';

     end

     t = t+1;

  end 
