% this function runs ttit instances of problem.  It first calls usrinpt.m to generate data, then calls Jacob.m to solve them.

clear

ttit = 100; % total run

% counters for total initial(psiini), final gap(psifin), number of iterations(tnb), total function evaluation(fevalt) of succeed runs(itt), number of soft failure(soft).   m:min function, k: []_- and []_+, j: Jordan Algebra
psiinim = 0; psifinm = 0; ittm = 0; tnbm = 0; fevaltm = 0; softfm = 0; % for min
tndtm = 0; sndtm = 0; fndtm = 0; % counter of perturbation for suc, softfail, fail. for min.

psiinik = 0; psifink = 0; ittk = 0; tnbk = 0; fevaltk = 0; softfk = 0; % for kjm
tndtk = 0; sndtk = 0; fndtk = 0; % counter of perturbation for suc, softfail, fail. for kjm.

psiinij = 0; psifinj = 0; ittj = 0; tnbj = 0; fevaltj = 0; softfj = 0; % for ja
tndtj = 0; sndtj = 0; fndtj = 0; % counter of perturbation for suc, softfail, fail. for Jordan Algebra.

for it = 1 : ttit  % run ttit instances
% optimal solutions and data  generation 

% call usrinpt to generate data.
 usrinpt

% M stores the starting position of each block.
  M(1)=1;
  for i = 2 : blck+1
    M(i) = M(i-1)+N(i-1);
  end
  dmsn = M(blck+1)-1;


% perturb data.  To get desired type, comment out other parts.

%% set y=0
% y(1:m) = 0;  %type 1

%  perturb b by 100%    %type 2
% b = b + norm(b)/m*(rand(m,1)-0.5)*2;

% perturb c by 100%    %type 3
% c = c + norm(c)/dmsn*(rand(dmsn,1)-0.5)*2;
%
%% perturb A by 100%     %type 4
 A = A + norm(A,'fro')/((m*dmsn))*(rand(size(m,dmsn))-0.5)*2;
%
%% perturb A, b, c        % type 5
 A = A + norm(A,'fro')/(m*dmsn)*(rand(size(m,dmsn))-0.5)*0.8*2;
 b = b + norm(b)/m*(rand(m,1)-0.5)*2;
 c = c + norm(c)/dmsn*(rand(dmsn,1)-0.5);
%
%% add a constraint  %type 6
% m = m+1;
% A = [A; 2*(rand(1,dmsn)-0.5)];
% b = [b;2*(rand-0.5)]; 
%% y = [y;0];
%
%% delete a block    %type 7
% blck = blck -1; 
% dmsn = M(blck+1)-1;
% A = A(:, 1:dmsn);
% c = c(1:dmsn);


% save the optimal points that generated the problem, they are needed to compare with the computed optimal points.
 xo = x; yo = y; so = s;

% solve problem

 % use min function 
 cd min
 fprintf('min\n');
 Jacob

if norm(F, inf) < tol  % succeed
   psiinim = psiinim + log10(f00);
   psifinm = psifinm + log10(norm(F, inf));
   ittm = ittm + k;
   fevaltm = fevaltm + feval;
   tnbm = tnbm + 1;
   tndtm = tndtm + ndt;

elseif norm(F, inf) < tol^(1/2)  % soft failure
   softfm = softfm + 1;
   sndtm = sndtm + ndt;
else
    fndtm = fndtm + ndt;
end

 % solve by []_- and []_+
 x = xo; s = so; y = yo;   % restore initial values
 cd ../kjm
 fprintf('projection\n');
Jacob
if norm(F, inf) < tol
   psiinik = psiinik + log10(f00);
   psifink = psifink + log10(norm(F, inf));
   ittk = ittk + k;
   fevaltk = fevaltk + feval;
   tnbk = tnbk + 1;
   tndtk = tndtk + ndt;

elseif norm(F, inf) < tol^(1/2) 
   softfk = softfk + 1;
   sndtk = sndtk + ndt;
else
   fndtk = fndtk + ndt;
end

 % solve by Jordan Algebra
 x = xo; s = so; y = yo;
cd ../ja
   fprintf('jordan algebra\n')
Jacob
if Psi < tol
   psiinij = psiinij + log10(f00);
   psifinj = psifinj + log10(norm(F, inf));
   ittj = ittj + k;
   fevaltj = fevaltj + feval;
   tnbj = tnbj + 1;
   tndtj = tndtj + ndt;

elseif norm(F, inf) < tol^(1/2)
   softfj = softfj + 1;
   sndtj = sndtj + ndt;
else
   fndtj = fndtj + ndt; 
end

cd ..

end

fprintf('\n\n==============Summary of output============\n\n')
fprintf( 'min = %d, projection = %d, jordan algebra = %d succeed\n\n', tnbm, tnbk, tnbj);
fprintf('min = %d, projection = %d, jordan algebra = %d softfail (norm < sqrt{tol))\n\n', softfm, softfk, softfj)
fprintf( 'min: average digits of initial gap = %f, final gap = %f, iteration = %f  total function evaluation = %f, perturbation = %f \n\n ', psiinim/tnbm, psifinm/tnbm, ittm/tnbm, fevaltm/tnbm, tndtm/tnbm)
fprintf( 'projection: average digits of initial gap = %f, final gap = %f, iteration = %f  total function evaluation = %f, perturbation = %f \n\n', psiinik/tnbk, psifink/tnbk, ittk/tnbk, fevaltk/tnbk, tndtk/tnbk)
fprintf( 'jordan algebra: average digits of initial gap = %f, final gap = %f, iteration = %f  total function evaluation = %f, perturbation = %f \n', psiinij/tnbj, psifinj/tnbj, ittj/tnbj, fevaltj/tnbj, tndtj/tnbj)
fprintf( '\n\n');
